from src.models.measurement_unit_model import measurement_unit_model
from src.logic.start_factory import start_factory
from src.settings.settings_manager import settings_manager

import unittest

from src.storage.storage import storage

#
# Набор автотестов для проверки работы фабричного метода
# #
class factory_test(unittest.TestCase):

    #
    # Проверка создания ед. измерения
    #
    def test_check_factory(self):
        # Подготовка
        unit = measurement_unit_model.create_kg()
        
        # Действие
        
        # Проверки
        assert isinstance(unit, measurement_unit_model)
        assert unit.base_coefficient == 1000
        
    # 
    # Проверка создание начальной номенклатуры
    #    
    def test_check_create_nomenclature(self):
        # Подготовка
        items = start_factory.create_nomenclature_list()
        
        # действие
        
        # Прверки
        assert len(items) > 0 
        
        
    #      
    # Проверка работы класса start_factory
    #
    def test_check_start_factor(self):
        # Подготовка
        manager = settings_manager()
        strg = storage()
        factory = start_factory( manager.settings,  strg)
        
        
        # Действие
        result = factory.create()
        
        
        # Проверка
        if manager.settings.is_first_run == True:
            assert len(result) > 0
            return
        
        
        assert len(result) == 0    
        
       
